import 'package:flutter/material.dart';

class MViewLayout extends CustomPainter {
  String text;

  TextStyle textStyle;

  MViewLayout({
    @required this.text,
    @required this.textStyle,
  });

  @override
  void paint(Canvas canvas, Size size) {
    print('size.height:${size.height}');
    print('size.width:${size.width}');
    var paint = new Paint();
    paint.color = textStyle.color;
    double offsetX = 0;
    double offsetY = size.height;
    bool newLine = true;
    double maxHeight = 0;

    maxHeight = findMaxHeight(text, textStyle);
    List<String> _textList = text.split(' ');

    for (int i = 0; i < _textList.length; i++) {
      print('offsetX$offsetX');
      print('offsetY$offsetY');

      ///   如果需要过滤空格，启动下面的代码
      ///      if (_textList[i] == '') {
      ///        print('count:$count');
      ///        continue;
      ///      }
      TextSpan span = new TextSpan(
        style: textStyle,
        text: _textList[i] + ' ',
      );
      TextPainter tp = new TextPainter(
          text: span,
          textAlign: TextAlign.left,
          textDirection: TextDirection.ltr);
      tp.layout();

      if (offsetX + tp.width > size.width) {
        newLine = true;
        offsetX = 0;
      }

      if (newLine) {
        offsetY -= maxHeight;
        newLine = false;
      }

      if (offsetY < -maxHeight) {
        return;
      }
      if (offsetY < 0) break;
      tp.paint(canvas, new Offset(offsetX, offsetY));
      offsetX += tp.width;
    }
  }

  double findMaxHeight(String text, TextStyle style) {
    double maxHeight = 0;
    List _textList = text.split(' ');
    for (int i = 0; i < _textList.length; i++) {
//      String str = new String.fromCharCode(rune);
      TextSpan span =
          new TextSpan(style: style, text: ' ' + _textList[i] + ' ');
      TextPainter tp = new TextPainter(
          text: span,
          textAlign: TextAlign.center,
          textDirection: TextDirection.ltr);
      tp.layout();
      maxHeight = max(maxHeight, tp.height);
    }

    return maxHeight;
  }

  @override
  bool shouldRepaint(MViewLayout oldDelegate) {
    return oldDelegate.text != text || oldDelegate.textStyle != textStyle;
  }

  double max(double a, double b) {
    if (a > b) {
      return a;
    } else {
      return b;
    }
  }
}
