library mgl_view;

import 'package:flutter/material.dart';

import 'MViewLayout.dart';

class MView extends StatelessWidget {
  const MView(this.child,
      {Key key,
      this.fontSize: 18.0,
      this.wordSpacing: 4,
      this.lineHeight: 1.1,
      this.fontFamily: 'Menk Hawang Tig',
      this.color: Colors.black})
      : super(key: key);

  final double fontSize;
  final double wordSpacing;
  final double lineHeight;
  final String fontFamily;
  final Color color;
  final String child;
  @override
  Widget build(BuildContext context) {
    return Container(
      child: RotatedBox(
        quarterTurns: 1,
        child: CustomPaint(
          painter: MViewLayout(
            text: child,
            textStyle: TextStyle(
                color: color,
                fontSize: fontSize,
//                letterSpacing: 2,
                wordSpacing: wordSpacing,
                textBaseline: TextBaseline.ideographic,
                fontFamily: fontFamily,
                height: lineHeight),
//            width: height,
//            height: width - fontSize,
          ),
        ),
      ),
    );
  }
}
